<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
        <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
          <a-row :gutter="24">
            <a-col :lg="6">
                    <a-form-item :label="searchFormSchema[0].label">
                        <JInput placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]"></JInput>
                    </a-form-item>
                </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[1].label">
                      <JSearchSelect placeholder="请输入" v-model:value="queryParam[searchFormSchema[1].field]" dict="projecttype"></JSearchSelect>
                      </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[2].label">
                      <JSelectDept placeholder="请输入"  v-model:value="jSelectDeptVal" :multiple="false" @change="updateJSelectDept"></JSelectDept>
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                    <a-form-item>
                      <a-space :size="5">
                        <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery" >查询</a-button>
                        <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset" >重置</a-button>
                      </a-space>
                    </a-form-item>
                 </a-col>
            </a-row>
        </a-form>

    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <!--<a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>-->
          <a-button v-show="showUpBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button v-show="showUpBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showUpBtn">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <StPlanManChangeModal @register="registerModal" @success="handleSuccess"></StPlanManChangeModal>
    <StPlanManChangeTranceModal @register="register2" @success="handleSuccess"></StPlanManChangeTranceModal>
  </div>
  </div>
</template>

<script lang="ts" name="project-plan-stPlanManChangeList" setup>
  import { reactive, ref, toRaw, unref } from 'vue';
import { batchDelete, changelist, deleteOne, getExportUrl, getImportUrl } from './StPlanMan.api';
import { columns, searchFormSchema } from './StPlanMan.data';
import StPlanManChangeModal from './components/StPlanManChangeModal.vue';
import StPlanManChangeTranceModal from './components/StPlanManChangeTranceModal.vue';
import { JInput, JSearchSelect, JSelectDept } from '/@/components/Form';
import { useModal } from '/@/components/Modal';
import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
  const showUpBtn = ref(false)
  const checkedKeys = ref<Array<string | number>>([]);
    const jSelectDeptVal = ref([])
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [register2, { openModal: openModal2 }] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '计划编制',
           api: changelist,
           columns,
           canResize:false,
           useSearchForm: false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 240,
               fixed:'right'
            },
            showTableSetting: false,
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'approveTime', order: 'desc'})
            },
      },
       exportConfig: {
            name:"计划编制",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {setProps,reload},{ rowSelection, selectedRowKeys }] = tableContext
  const labelCol = reactive({
    xs: {span: 24},
    sm: {span: 8},
  })
  const wrapperCol = reactive({
      xs: {span: 24},
      sm: {span: 16},
  })
  const queryParam = reactive({
  });
  function initParam() {
    const schemas = unref(searchFormSchema);
    schemas.forEach((item) => {
      queryParam[item.field] = ''
    });
    queryParam['checkClassFiy'] = null
    queryParam['lableCodes'] = ''
    jSelectDeptVal.value = []
  }
  initParam()
  function updateJSelectDept(val){
    if(val.length>0){
      queryParam[searchFormSchema[2].field] = val[0]
    }else{
      jSelectDeptVal.value = []
      queryParam[searchFormSchema[2].field] = ''
    }
  }
  function searchQuery(){
      setProps({searchInfo:toRaw(queryParam)});
      reload()
  }
  function searchReset(){
    initParam()
    reload();
}
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件 变更
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       planFlag:'4', // 变更待审核
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
      /**
    * 编辑事件 废止
    */
  function handleRepeal(record: Recordable) {
     openModal(true, {
       planFlag:'7', // 废止待审核
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 变更记录
   */
  function handleRecord(record: Recordable) {
     openModal2(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
       {
            label: '废止',
            disabled: record['planFlag']=='4'||record['planFlag']=='7'||record['planFlag']=='9',
            onClick: handleRepeal.bind(null, record),
         },
         {
           label: '变更',
           disabled: record['planFlag']=='4'||record['planFlag']=='7'||record['planFlag']=='9',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, 
         {
           label: '变更记录',
           onClick: handleRecord.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
       ]
   }


</script>

<style scoped>

</style>